/**
 * The SMS Works API
 * The SMS Works provides a low-cost, reliable SMS API for developers. Pay only for delivered texts, all failed messages are refunded.
 *
 * OpenAPI spec version: 1.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ApiKeyResponse', 'model/BatchMessage', 'model/BatchMessageResponse', 'model/CancelledMessageResponse', 'model/ErrorModel', 'model/Login', 'model/Message', 'model/MessageResponse', 'model/MessageResponseFailureReason', 'model/MessagesResponse', 'model/MessagesResponseMessages', 'model/Query', 'model/ScheduledBatchResponse', 'model/ScheduledMessageResponse', 'model/SendMessageResponse', 'model/TestResponse', 'model/TokenResponse', 'model/ExtendedErrorModel', 'api/AuthApi', 'api/BatchMessagesApi', 'api/MessagesApi', 'api/UtilsApi'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('./ApiClient'), require('./model/ApiKeyResponse'), require('./model/BatchMessage'), require('./model/BatchMessageResponse'), require('./model/CancelledMessageResponse'), require('./model/ErrorModel'), require('./model/Login'), require('./model/Message'), require('./model/MessageResponse'), require('./model/MessageResponseFailureReason'), require('./model/MessagesResponse'), require('./model/MessagesResponseMessages'), require('./model/Query'), require('./model/ScheduledBatchResponse'), require('./model/ScheduledMessageResponse'), require('./model/SendMessageResponse'), require('./model/TestResponse'), require('./model/TokenResponse'), require('./model/ExtendedErrorModel'), require('./api/AuthApi'), require('./api/BatchMessagesApi'), require('./api/MessagesApi'), require('./api/UtilsApi'));
  }
}(function(ApiClient, ApiKeyResponse, BatchMessage, BatchMessageResponse, CancelledMessageResponse, ErrorModel, Login, Message, MessageResponse, MessageResponseFailureReason, MessagesResponse, MessagesResponseMessages, Query, ScheduledBatchResponse, ScheduledMessageResponse, SendMessageResponse, TestResponse, TokenResponse, ExtendedErrorModel, AuthApi, BatchMessagesApi, MessagesApi, UtilsApi) {
  'use strict';

  /**
   * The_SMS_Works_provides_a_low_cost_reliable_SMS_API_for_developers__Pay_only_for_delivered_texts_all_failed_messages_are_refunded_.<br>
   * The <code>index</code> module provides access to constructors for all the classes which comprise the public API.
   * <p>
   * An AMD (recommended!) or CommonJS application will generally do something equivalent to the following:
   * <pre>
   * var TheSmsWorksApi = require('index'); // See note below*.
   * var xxxSvc = new TheSmsWorksApi.XxxApi(); // Allocate the API class we're going to use.
   * var yyyModel = new TheSmsWorksApi.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * <em>*NOTE: For a top-level AMD script, use require(['index'], function(){...})
   * and put the application logic within the callback function.</em>
   * </p>
   * <p>
   * A non-AMD browser application (discouraged) might do something like this:
   * <pre>
   * var xxxSvc = new TheSmsWorksApi.XxxApi(); // Allocate the API class we're going to use.
   * var yyy = new TheSmsWorksApi.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * </p>
   * @module index
   * @version 1.0.0
   */
  var exports = {
    /**
     * The ApiClient constructor.
     * @property {module:ApiClient}
     */
    ApiClient: ApiClient,
    /**
     * The ApiKeyResponse model constructor.
     * @property {module:model/ApiKeyResponse}
     */
    ApiKeyResponse: ApiKeyResponse,
    /**
     * The BatchMessage model constructor.
     * @property {module:model/BatchMessage}
     */
    BatchMessage: BatchMessage,
    /**
     * The BatchMessageResponse model constructor.
     * @property {module:model/BatchMessageResponse}
     */
    BatchMessageResponse: BatchMessageResponse,
    /**
     * The CancelledMessageResponse model constructor.
     * @property {module:model/CancelledMessageResponse}
     */
    CancelledMessageResponse: CancelledMessageResponse,
    /**
     * The ErrorModel model constructor.
     * @property {module:model/ErrorModel}
     */
    ErrorModel: ErrorModel,
    /**
     * The Login model constructor.
     * @property {module:model/Login}
     */
    Login: Login,
    /**
     * The Message model constructor.
     * @property {module:model/Message}
     */
    Message: Message,
    /**
     * The MessageResponse model constructor.
     * @property {module:model/MessageResponse}
     */
    MessageResponse: MessageResponse,
    /**
     * The MessageResponseFailureReason model constructor.
     * @property {module:model/MessageResponseFailureReason}
     */
    MessageResponseFailureReason: MessageResponseFailureReason,
    /**
     * The MessagesResponse model constructor.
     * @property {module:model/MessagesResponse}
     */
    MessagesResponse: MessagesResponse,
    /**
     * The MessagesResponseMessages model constructor.
     * @property {module:model/MessagesResponseMessages}
     */
    MessagesResponseMessages: MessagesResponseMessages,
    /**
     * The Query model constructor.
     * @property {module:model/Query}
     */
    Query: Query,
    /**
     * The ScheduledBatchResponse model constructor.
     * @property {module:model/ScheduledBatchResponse}
     */
    ScheduledBatchResponse: ScheduledBatchResponse,
    /**
     * The ScheduledMessageResponse model constructor.
     * @property {module:model/ScheduledMessageResponse}
     */
    ScheduledMessageResponse: ScheduledMessageResponse,
    /**
     * The SendMessageResponse model constructor.
     * @property {module:model/SendMessageResponse}
     */
    SendMessageResponse: SendMessageResponse,
    /**
     * The TestResponse model constructor.
     * @property {module:model/TestResponse}
     */
    TestResponse: TestResponse,
    /**
     * The TokenResponse model constructor.
     * @property {module:model/TokenResponse}
     */
    TokenResponse: TokenResponse,
    /**
     * The ExtendedErrorModel model constructor.
     * @property {module:model/ExtendedErrorModel}
     */
    ExtendedErrorModel: ExtendedErrorModel,
    /**
     * The AuthApi service constructor.
     * @property {module:api/AuthApi}
     */
    AuthApi: AuthApi,
    /**
     * The BatchMessagesApi service constructor.
     * @property {module:api/BatchMessagesApi}
     */
    BatchMessagesApi: BatchMessagesApi,
    /**
     * The MessagesApi service constructor.
     * @property {module:api/MessagesApi}
     */
    MessagesApi: MessagesApi,
    /**
     * The UtilsApi service constructor.
     * @property {module:api/UtilsApi}
     */
    UtilsApi: UtilsApi
  };

  return exports;
}));
