/**
 * The SMS Works API
 * The SMS Works provides a low-cost, reliable SMS API for developers. Pay only for delivered texts, all failed messages are refunded.
 *
 * OpenAPI spec version: 1.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.TheSmsWorksApi) {
      root.TheSmsWorksApi = {};
    }
    root.TheSmsWorksApi.Login = factory(root.TheSmsWorksApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Login model module.
   * @module model/Login
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>Login</code>.
   * authorisation object
   * @alias module:model/Login
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>Login</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Login} obj Optional instance to populate.
   * @return {module:model/Login} The populated <code>Login</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('customerid')) {
        obj['customerid'] = ApiClient.convertToType(data['customerid'], 'String');
      }
      if (data.hasOwnProperty('key')) {
        obj['key'] = ApiClient.convertToType(data['key'], 'String');
      }
      if (data.hasOwnProperty('secret')) {
        obj['secret'] = ApiClient.convertToType(data['secret'], 'String');
      }
    }
    return obj;
  }

  /**
   * Your customer ID, available from your account area at https://thesmsworks.co.uk/user/login
   * @member {String} customerid
   */
  exports.prototype['customerid'] = undefined;
  /**
   * API Key
   * @member {String} key
   */
  exports.prototype['key'] = undefined;
  /**
   * API Secret
   * @member {String} secret
   */
  exports.prototype['secret'] = undefined;



  return exports;
}));


