/**
 * The SMS Works API
 * The SMS Works provides a low-cost, reliable SMS API for developers. Pay only for delivered texts, all failed messages are refunded.
 *
 * OpenAPI spec version: 1.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.TheSmsWorksApi) {
      root.TheSmsWorksApi = {};
    }
    root.TheSmsWorksApi.Message = factory(root.TheSmsWorksApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Message model module.
   * @module model/Message
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>Message</code>.
   * SMS message object
   * @alias module:model/Message
   * @class
   * @param sender {String} The sender of the message. Should be no longer than 11 characters for alphanumeric or 15 characters for numeric sender ID's. No spaces or special characters.
   * @param destination {String} Telephone number of the recipient
   * @param content {String} Message to send to the recipient. Content can be up to 640 characters in length. You will be charged 1 credit for each 160 characters, up to a maximum of 4 credits. Messages sent to numbers registered outside the UK will be charged double credits (i.e. 2 credits per 160 characters, up to maximum of 8 credits).
   * @param schedule {String} Date at which to send the message. This is only used by the message/schedule service and can be left empty for other services.
   */
  var exports = function(sender, destination, content, schedule) {
    var _this = this;

    _this['sender'] = sender;
    _this['destination'] = destination;
    _this['content'] = content;
    _this['schedule'] = schedule;

  };

  /**
   * Constructs a <code>Message</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Message} obj Optional instance to populate.
   * @return {module:model/Message} The populated <code>Message</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('sender')) {
        obj['sender'] = ApiClient.convertToType(data['sender'], 'String');
      }
      if (data.hasOwnProperty('destination')) {
        obj['destination'] = ApiClient.convertToType(data['destination'], 'String');
      }
      if (data.hasOwnProperty('content')) {
        obj['content'] = ApiClient.convertToType(data['content'], 'String');
      }
      if (data.hasOwnProperty('schedule')) {
        obj['schedule'] = ApiClient.convertToType(data['schedule'], 'String');
      }
      if (data.hasOwnProperty('tag')) {
        obj['tag'] = ApiClient.convertToType(data['tag'], 'String');
      }
    }
    return obj;
  }

  /**
   * The sender of the message. Should be no longer than 11 characters for alphanumeric or 15 characters for numeric sender ID's. No spaces or special characters.
   * @member {String} sender
   */
  exports.prototype['sender'] = undefined;
  /**
   * Telephone number of the recipient
   * @member {String} destination
   */
  exports.prototype['destination'] = undefined;
  /**
   * Message to send to the recipient. Content can be up to 640 characters in length. You will be charged 1 credit for each 160 characters, up to a maximum of 4 credits. Messages sent to numbers registered outside the UK will be charged double credits (i.e. 2 credits per 160 characters, up to maximum of 8 credits).
   * @member {String} content
   */
  exports.prototype['content'] = undefined;
  /**
   * Date at which to send the message. This is only used by the message/schedule service and can be left empty for other services.
   * @member {String} schedule
   */
  exports.prototype['schedule'] = undefined;
  /**
   * An identifying label for the message, which you can use to filter and report on messages you've sent later. Ideal for campaigns.
   * @member {String} tag
   */
  exports.prototype['tag'] = undefined;



  return exports;
}));


