/**
 * The SMS Works API
 * The SMS Works provides a low-cost, reliable SMS API for developers. Pay only for delivered texts, all failed messages are refunded.
 *
 * OpenAPI spec version: 1.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MessageResponseFailureReason'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./MessageResponseFailureReason'));
  } else {
    // Browser globals (root is window)
    if (!root.TheSmsWorksApi) {
      root.TheSmsWorksApi = {};
    }
    root.TheSmsWorksApi.MessageResponse = factory(root.TheSmsWorksApi.ApiClient, root.TheSmsWorksApi.MessageResponseFailureReason);
  }
}(this, function(ApiClient, MessageResponseFailureReason) {
  'use strict';




  /**
   * The MessageResponse model module.
   * @module model/MessageResponse
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>MessageResponse</code>.
   * @alias module:model/MessageResponse
   * @class
   * @param batchid {String} 
   * @param content {String} 
   * @param created {String} 
   * @param customerid {String} 
   * @param destination {Number} 
   * @param keyword {String} 
   * @param messageid {String} 
   * @param modified {String} 
   * @param schedule {String} 
   * @param status {String} 
   * @param sender {String} 
   * @param tag {String} 
   */
  var exports = function(batchid, content, created, customerid, destination, keyword, messageid, modified, schedule, status, sender, tag) {
    var _this = this;

    _this['batchid'] = batchid;
    _this['content'] = content;
    _this['created'] = created;
    _this['customerid'] = customerid;
    _this['destination'] = destination;


    _this['keyword'] = keyword;
    _this['messageid'] = messageid;
    _this['modified'] = modified;
    _this['schedule'] = schedule;
    _this['status'] = status;
    _this['sender'] = sender;
    _this['tag'] = tag;
  };

  /**
   * Constructs a <code>MessageResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MessageResponse} obj Optional instance to populate.
   * @return {module:model/MessageResponse} The populated <code>MessageResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('batchid')) {
        obj['batchid'] = ApiClient.convertToType(data['batchid'], 'String');
      }
      if (data.hasOwnProperty('content')) {
        obj['content'] = ApiClient.convertToType(data['content'], 'String');
      }
      if (data.hasOwnProperty('created')) {
        obj['created'] = ApiClient.convertToType(data['created'], 'String');
      }
      if (data.hasOwnProperty('customerid')) {
        obj['customerid'] = ApiClient.convertToType(data['customerid'], 'String');
      }
      if (data.hasOwnProperty('destination')) {
        obj['destination'] = ApiClient.convertToType(data['destination'], 'Number');
      }
      if (data.hasOwnProperty('failureReason')) {
        obj['failureReason'] = MessageResponseFailureReason.constructFromObject(data['failureReason']);
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('keyword')) {
        obj['keyword'] = ApiClient.convertToType(data['keyword'], 'String');
      }
      if (data.hasOwnProperty('messageid')) {
        obj['messageid'] = ApiClient.convertToType(data['messageid'], 'String');
      }
      if (data.hasOwnProperty('modified')) {
        obj['modified'] = ApiClient.convertToType(data['modified'], 'String');
      }
      if (data.hasOwnProperty('schedule')) {
        obj['schedule'] = ApiClient.convertToType(data['schedule'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('sender')) {
        obj['sender'] = ApiClient.convertToType(data['sender'], 'String');
      }
      if (data.hasOwnProperty('tag')) {
        obj['tag'] = ApiClient.convertToType(data['tag'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {String} batchid
   */
  exports.prototype['batchid'] = undefined;
  /**
   * @member {String} content
   */
  exports.prototype['content'] = undefined;
  /**
   * @member {String} created
   */
  exports.prototype['created'] = undefined;
  /**
   * @member {String} customerid
   */
  exports.prototype['customerid'] = undefined;
  /**
   * @member {Number} destination
   */
  exports.prototype['destination'] = undefined;
  /**
   * @member {module:model/MessageResponseFailureReason} failureReason
   */
  exports.prototype['failureReason'] = undefined;
  /**
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * @member {String} keyword
   */
  exports.prototype['keyword'] = undefined;
  /**
   * @member {String} messageid
   */
  exports.prototype['messageid'] = undefined;
  /**
   * @member {String} modified
   */
  exports.prototype['modified'] = undefined;
  /**
   * @member {String} schedule
   */
  exports.prototype['schedule'] = undefined;
  /**
   * @member {String} status
   */
  exports.prototype['status'] = undefined;
  /**
   * @member {String} sender
   */
  exports.prototype['sender'] = undefined;
  /**
   * @member {String} tag
   */
  exports.prototype['tag'] = undefined;



  return exports;
}));


